unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, jpeg, StdCtrls, ImgList;

type
  TDeistvie=record
   number:integer;
   inchar:char;
   cmd:char;
   ndstv:integer;
  end;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image2: TImage;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ImageList1: TImageList;
    Label7: TLabel;
    Button2: TButton;
    Button3: TButton;
    Timer1: TTimer;
    Button4: TButton;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    OpenDialog1: TOpenDialog;
    Button5: TButton;
    Button6: TButton;
    ListBox1: TListBox;
    Bevel1: TBevel;
    Button1: TButton;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Button7: TButton;
    Label13: TLabel;
    Label14: TLabel;
    Button8: TButton;
    Shape1: TShape;
    Button9: TButton;
    Button10: TButton;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Image3: TImage;
    Image4: TImage;
    Label15: TLabel;
    Label16: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
    proh:integer;
    mv:boolean;
    pos1:integer;
    mx:integer;
    scnt:integer;
    crs:integer;
    isdone:boolean;
    sost:array of TDeistvie;
    procedure DrawTape(pos,x:smallint);
    procedure NormalPos;
    procedure NormalPos1;
    procedure LoadFile(fname:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  defLength:integer;
  tape:string;

implementation

{$R *.DFM}

procedure TForm1.NormalPos;
var x:string;
begin
while(pos1<0) do begin
 inc(pos1);
 x:='^'+tape;
 tape:=x;
 inc(DefLength);
 label6.caption:=inttostr(deflength);
end;
end;

procedure TForm1.NormalPos1;
begin
 tape:=tape+'^';
 inc(DefLength);
 label6.caption:=inttostr(deflength);
end;

procedure TForm1.DrawTape(pos,x:smallint);
var i:smallint;
begin
 if pos<0 then NormalPos;
 if pos>deflength-30 then NormalPos1;
 image1.canvas.brush.color:=clWhite;
 image1.canvas.floodfill(1,1,clREd,fsBorder);
 for i:=0 to 50 do begin
  imagelist1.draw(image1.canvas,i*16-x,5,1);
 end;
 image1.canvas.brush.color:=$0088FFFF;
 for i:=1 to 45 do begin
  if tape[i+pos+1]<>'^' then image1.canvas.textout(i*16-x+3,7,tape[i+pos+1]);
  if tape[i+pos+1]='^' then imagelist1.draw(image1.canvas,i*16-x,6,0);
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:smallint;
begin
 mv:=false;
 deflength:=50;
 tape:='   1.0 .   .. MEDIA STUDIO DESIGN   .';
 label6.caption:='45';
 DrawTape(0,0);
 label3.caption:='Undefined';
 label4.caption:='0';
 isdone:=false;
 LoadFile('prg1.mt');
 button6.click;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
mv:=true;
mx:=0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
timer1.interval:=50;
if mv=true then begin
case mx of
0:begin
   image1.canvas.floodfill(1,1,clREd,fsBorder);
   DrawTape(pos1,8);
   image1.repaint;
   mx:=1;
  end;
1:begin
   image1.canvas.brush.color:=clWhite;
   image1.canvas.floodfill(1,1,clREd,fsBorder);
   DrawTape(pos1,16);
   image1.repaint;
   inc(pos1);
   mx:=2;
  end;
2:begin
   image1.canvas.floodfill(1,1,clREd,fsBorder);
   DrawTape(pos1,0);
   image1.repaint;
   mv:=false;
   label4.caption:=inttostr(pos1);
  end;
3:begin
   image1.canvas.floodfill(1,1,clREd,fsBorder);
   DrawTape(pos1,-8);
   image1.repaint;
   mx:=4;
  end;
4:begin
   image1.canvas.floodfill(1,1,clREd,fsBorder);
   DrawTape(pos1,-16);
   image1.repaint;
   dec(pos1);
   mx:=5;
  end;
5:begin
   image1.canvas.floodfill(1,1,clREd,fsBorder);
   DrawTape(pos1,0);
   image1.repaint;
   mv:=false;
   label4.caption:=inttostr(pos1);
  end;
end;
end else
if isdone=true then button5.click;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
mv:=true;
mx:=3;
end;

procedure TForm1.LoadFile(fname:string);
var f:textfile;
    i:smallint;
    x:string;
    n1:integer;
    n2:integer;
    cmd1,cmd2:char;
begin
assignfile(f,fname);
reset(f);
readln(f);
readln(f,tape);
readln(f);
readln(f,scnt);
label12.caption:=inttostr(scnt);
readln(f,scnt);
setlength(sost,scnt+1);
i:=0;
listbox1.clear;
repeat
inc(i);
read(f,n1);
read(f,cmd1);
read(f,cmd1);
read(f,cmd2);
read(f,cmd2);
read(f,n2);
sost[i].number:=n1;
sost[i].cmd:=cmd1;
sost[i].inchar:=cmd2;
sost[i].ndstv:=n2;
listbox1.items.add(' q'+inttostr(n1)+' '+cmd1+'  ->  '+cmd2+' q'+inttostr(n2)+' ');
until(i=scnt);

closefile(f);
x:='^'+tape;
tape:=x;
dec(pos1);
for i:=1 to 25 do tape:=tape+'^';
drawtape(pos1,0);
drawtape(pos1,0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
opendialog1.execute;
LoadFile(opendialog1.filename);
end;

procedure TForm1.Button5Click(Sender: TObject);
var i:integer;
begin
inc(proh);
label14.caption:=inttostr(proh);
isdone:=true;
for i:=1 to scnt do begin
 if crs=0 then begin
  isdone:=false;
  exit;
 end;
 if sost[i].number=crs then begin
  if sost[i].cmd=tape[pos1+3] then begin
//   showmessage(inttostr(i));
   if(sost[i].inchar<>'H')and(sost[i].inchar<>'R')and(sost[i].inchar<>'L')then begin
     tape[pos1+3]:=sost[i].inchar;
     crs:=sost[i].ndstv;
     label3.caption:=inttostr(crs);     
     exit;
   end;
   crs:=sost[i].ndstv;
   label3.caption:=inttostr(crs);
   if sost[i].inchar='R' then begin
    button4.click;
    exit;
   end;
   if sost[i].inchar='L' then begin
    button3.click;
    exit;
   end;
  end;
 end;
end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
proh:=0;
crs:=1;
button5.click;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
IsDone:=false;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
IsDone:=true;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
pos1:=0;
IsDone:=false;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
 close;
end;

end.
